Index: palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4671)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+! 
+! 4577 2020-06-25 09:53:58Z raasch
 ! further re-formatting concerning Fortran parameter variables
 !
@@ -1557,5 +1560,6 @@
                             surf_def_h(0)%qcsws, surf_def_h(1)%qcsws,                              &
                             surf_def_h(2)%qcsws,                                                   &
-                            surf_lsm_h%qcsws,    surf_usm_h%qcsws,                                 &
+                            surf_lsm_h(0)%qcsws, surf_lsm_h(1)%qcsws,                              &
+                            surf_usm_h(0)%qcsws, surf_usm_h(1)%qcsws,                              &
                             surf_def_v(0)%qcsws, surf_def_v(1)%qcsws,                              &
                             surf_def_v(2)%qcsws, surf_def_v(3)%qcsws,                              &
@@ -1647,5 +1651,6 @@
                             surf_def_h(0)%ncsws, surf_def_h(1)%ncsws,                              &
                             surf_def_h(2)%ncsws,                                                   &
-                            surf_lsm_h%ncsws,    surf_usm_h%ncsws,                                 &
+                            surf_lsm_h(0)%ncsws, surf_lsm_h(1)%ncsws,                              &
+                            surf_usm_h(0)%ncsws, surf_usm_h(1)%ncsws,                              &
                             surf_def_v(0)%ncsws, surf_def_v(1)%ncsws,                              &
                             surf_def_v(2)%ncsws, surf_def_v(3)%ncsws,                              &
@@ -1745,5 +1750,6 @@
                             surf_def_h(0)%qisws, surf_def_h(1)%qisws,                              &
                             surf_def_h(2)%qisws,                                                   &
-                            surf_lsm_h%qisws,    surf_usm_h%qisws,                                 &
+                            surf_lsm_h(0)%qisws, surf_lsm_h(1)%qisws,                              &
+                            surf_usm_h(0)%qisws, surf_usm_h(1)%qisws,                              &
                             surf_def_v(0)%qisws, surf_def_v(1)%qisws,                              &
                             surf_def_v(2)%qisws, surf_def_v(3)%qisws,                              &
@@ -1835,5 +1841,6 @@
                             surf_def_h(0)%nisws, surf_def_h(1)%nisws,                              &
                             surf_def_h(2)%nisws,                                                   &
-                            surf_lsm_h%nisws,    surf_usm_h%nisws,                                 &
+                            surf_lsm_h(0)%nisws, surf_lsm_h(1)%nisws,                              &
+                            surf_usm_h(0)%nisws, surf_usm_h(1)%nisws,                              &
                             surf_def_v(0)%nisws, surf_def_v(1)%nisws,                              &
                             surf_def_v(2)%nisws, surf_def_v(3)%nisws,                              &
@@ -1933,5 +1940,6 @@
                             surf_def_h(0)%qrsws, surf_def_h(1)%qrsws,                              &
                             surf_def_h(2)%qrsws,                                                   &
-                            surf_lsm_h%qrsws,    surf_usm_h%qrsws,                                 &
+                            surf_lsm_h(0)%qrsws, surf_lsm_h(1)%qrsws,                              &
+                            surf_usm_h(0)%qrsws, surf_usm_h(1)%qrsws,                              &
                             surf_def_v(0)%qrsws, surf_def_v(1)%qrsws,                              &
                             surf_def_v(2)%qrsws, surf_def_v(3)%qrsws,                              &
@@ -2023,5 +2031,6 @@
                             surf_def_h(0)%nrsws, surf_def_h(1)%nrsws,                              &
                             surf_def_h(2)%nrsws,                                                   &
-                            surf_lsm_h%nrsws,    surf_usm_h%nrsws,                                 &
+                            surf_lsm_h(0)%nrsws, surf_lsm_h(1)%nrsws,                              &
+                            surf_usm_h(0)%nrsws, surf_usm_h(1)%nrsws,                              &
                             surf_def_v(0)%nrsws, surf_def_v(1)%nrsws,                              &
                             surf_def_v(2)%nrsws, surf_def_v(3)%nrsws,                              &
@@ -2122,5 +2131,6 @@
                             surf_def_h(0)%qcsws, surf_def_h(1)%qcsws,                              &
                             surf_def_h(2)%qcsws,                                                   &
-                            surf_lsm_h%qcsws,    surf_usm_h%qcsws,                                 &
+                            surf_lsm_h(0)%qcsws, surf_lsm_h(1)%qcsws,                              &
+                            surf_usm_h(0)%qcsws, surf_usm_h(1)%qcsws,                              &
                             surf_def_v(0)%qcsws, surf_def_v(1)%qcsws,                              &
                             surf_def_v(2)%qcsws, surf_def_v(3)%qcsws,                              &
@@ -2179,5 +2189,6 @@
                             surf_def_h(0)%ncsws, surf_def_h(1)%ncsws,                              &
                             surf_def_h(2)%ncsws,                                                   &
-                            surf_lsm_h%ncsws,    surf_usm_h%ncsws,                                 &
+                            surf_lsm_h(0)%ncsws, surf_lsm_h(1)%ncsws,                              &
+                            surf_usm_h(0)%ncsws, surf_usm_h(1)%ncsws,                              &
                             surf_def_v(0)%ncsws, surf_def_v(1)%ncsws,                              &
                             surf_def_v(2)%ncsws, surf_def_v(3)%ncsws,                              &
@@ -2243,5 +2254,6 @@
                             surf_def_h(0)%qisws, surf_def_h(1)%qisws,                              &
                             surf_def_h(2)%qisws,                                                   &
-                            surf_lsm_h%qisws,    surf_usm_h%qisws,                                 &
+                            surf_lsm_h(0)%qisws, surf_lsm_h(1)%qisws,                              &
+                            surf_usm_h(0)%qisws, surf_usm_h(1)%qisws,                              &
                             surf_def_v(0)%qisws, surf_def_v(1)%qisws,                              &
                             surf_def_v(2)%qisws, surf_def_v(3)%qisws,                              &
@@ -2300,5 +2312,6 @@
                             surf_def_h(0)%nisws, surf_def_h(1)%nisws,                              &
                             surf_def_h(2)%nisws,                                                   &
-                            surf_lsm_h%nisws,    surf_usm_h%nisws,                                 &
+                            surf_lsm_h(0)%nisws, surf_lsm_h(1)%nisws,                              &
+                            surf_usm_h(0)%nisws, surf_usm_h(1)%nisws,                              &
                             surf_def_v(0)%nisws, surf_def_v(1)%nisws,                              &
                             surf_def_v(2)%nisws, surf_def_v(3)%nisws,                              &
@@ -2364,5 +2377,6 @@
                             surf_def_h(0)%qrsws, surf_def_h(1)%qrsws,                              &
                             surf_def_h(2)%qrsws,                                                   &
-                            surf_lsm_h%qrsws,    surf_usm_h%qrsws,                                 &
+                            surf_lsm_h(0)%qrsws, surf_lsm_h(1)%qrsws,                              &
+                            surf_usm_h(0)%qrsws, surf_usm_h(1)%qrsws,                              &
                             surf_def_v(0)%qrsws, surf_def_v(1)%qrsws,                              &
                             surf_def_v(2)%qrsws, surf_def_v(3)%qrsws,                              &
@@ -2421,5 +2435,6 @@
                             surf_def_h(0)%nrsws, surf_def_h(1)%nrsws,                              &
                             surf_def_h(2)%nrsws,                                                   &
-                            surf_lsm_h%nrsws,    surf_usm_h%nrsws,                                 &
+                            surf_lsm_h(0)%nrsws, surf_lsm_h(1)%nrsws,                              &
+                            surf_usm_h(0)%nrsws, surf_usm_h(1)%nrsws,                              &
                             surf_def_v(0)%nrsws, surf_def_v(1)%nrsws,                              &
                             surf_def_v(2)%nrsws, surf_def_v(3)%nrsws,                              &
Index: palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 4671)
@@ -21,9 +21,12 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+! 
+! 4559 2020-06-11 08:51:48Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -1486,17 +1489,17 @@
 !-- horizontal urban walls that are at k == 0 (building is lower than the first grid point). Hence,
 !-- in order to have only emissions at streets, set the surfaces emissions to zero at urban walls.
-             IF  ( surf_usm_h%ns >=1 )  surf_usm_h%cssws = 0.0_wp
+             IF  ( surf_usm_h(0)%ns >=1 )  surf_usm_h(0)%cssws = 0.0_wp
 
 !
 !--          Treat land-surfaces.
-             DO  m = 1, surf_lsm_h%ns
-
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-                k = surf_lsm_h%k(m)
+             DO  m = 1, surf_lsm_h(0)%ns
+
+                i = surf_lsm_h(0)%i(m)
+                j = surf_lsm_h(0)%j(m)
+                k = surf_lsm_h(0)%k(m)
 
 !
 !--             Set everything to zero then reassign according to street type
-                surf_lsm_h%cssws(:,m) = 0.0_wp
+                surf_lsm_h(0)%cssws(:,m) = 0.0_wp
 
                 IF  ( street_type_f%var(j,i) >= main_street_id  .AND.                              &
@@ -1515,5 +1518,5 @@
 !
 !--                      kg/(m^2*s) * kg/m^3
-                         surf_lsm_h%cssws(match_spec_model(ispec),m) =                             &
+                         surf_lsm_h(0)%cssws(match_spec_model(ispec),m) =                          &
                                    emiss_factor_main(match_spec_input(ispec)) *                    &
                                    emis_distribution(1,j,i,ispec)             *   &     ! kg/(m^2*s)
@@ -1527,5 +1530,5 @@
 !
 !--                      ppm/s *m *kg/m^3
-                         surf_lsm_h%cssws(match_spec_model(ispec),m) =                             &
+                         surf_lsm_h(0)%cssws(match_spec_model(ispec),m) =                          &
                                    emiss_factor_main( match_spec_input(ispec) ) *                  &
                                    emis_distribution(1,j,i,ispec) *       &     ! micromoles/(m^2*s)
@@ -1553,5 +1556,5 @@
 !
 !--                      kg/(m^2*s) * kg/m^3
-                         surf_lsm_h%cssws(match_spec_model(ispec),m) =                             &
+                         surf_lsm_h(0)%cssws(match_spec_model(ispec),m) =                          &
                                    emiss_factor_side( match_spec_input(ispec) ) *                  &
                                    emis_distribution(1,j,i,ispec)               * &     ! kg/(m^2*s)
@@ -1564,5 +1567,5 @@
 !
 !--                      ppm/s *m *kg/m^3
-                         surf_lsm_h%cssws(match_spec_model(ispec),m) =                             &
+                         surf_lsm_h(0)%cssws(match_spec_model(ispec),m) =                          &
                                    emiss_factor_side( match_spec_input(ispec) ) *                  &
                                    emis_distribution(1,j,i,ispec)        *   &  ! micromoles/(m^2*s)
@@ -1579,5 +1582,5 @@
 !                ELSE
 !
-!                   surf_lsm_h%cssws(:,m) = 0.0_wp
+!                   surf_lsm_h(0)%cssws(:,m) = 0.0_wp
 
                 ENDIF  ! street type
@@ -1649,9 +1652,9 @@
 !
 !--          LSM surfaces
-             DO  m = 1, surf_lsm_h%ns
-
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-                k = surf_lsm_h%k(m)
+             DO  m = 1, surf_lsm_h(0)%ns
+
+                i = surf_lsm_h(0)%i(m)
+                j = surf_lsm_h(0)%j(m)
+                k = surf_lsm_h(0)%k(m)
 
                 IF  ( emis_distribution(1,j,i,ispec) > 0.0_wp )  THEN
@@ -1663,7 +1666,7 @@
                          TRIM( spc_names( match_spec_model(ispec) ) ) == "PM10" )  THEN
 
-                      surf_lsm_h%cssws(match_spec_model(ispec),m) =           &    ! kg/m2/s * kg/m3
-                                             emis_distribution(1,j,i,ispec) * &    ! kg/m2/s
-                                             rho_air(k)                            ! kg/m^3
+                      surf_lsm_h(0)%cssws(match_spec_model(ispec),m) =           &    ! kg/m2/s * kg/m3
+                                             emis_distribution(1,j,i,ispec) *    &    ! kg/m2/s
+                                             rho_air(k)                               ! kg/m^3
 
                    ELSE
@@ -1674,9 +1677,9 @@
                             emt_att%species_name(match_spec_input(ispec)) == "VOC" )  THEN
 
-                         surf_lsm_h%cssws(match_spec_model(ispec),m) =      &   ! ppm/s * m * kg/m3
-                               emis_distribution(1,j,i,ispec) *             &   ! mole/m2/s
-                               conv_to_ratio(k,j,i)           *             &   ! m^3/mole
-                               ratio2ppm                      *             &   ! ppm
-                               rho_air(k)                                       ! kg/m^3
+                         surf_lsm_h(0)%cssws(match_spec_model(ispec),m) =      &   ! ppm/s * m * kg/m3
+                               emis_distribution(1,j,i,ispec) *                &   ! mole/m2/s
+                               conv_to_ratio(k,j,i)           *                &   ! m^3/mole
+                               ratio2ppm                      *                &   ! ppm
+                               rho_air(k)                                          ! kg/m^3
 
 !
@@ -1684,10 +1687,10 @@
                       ELSE
 
-                         surf_lsm_h%cssws(match_spec_model(ispec),m) =       &   ! ppm/s * m * kg/m3
-                               emis_distribution(1,j,i,ispec) *              &   ! kg/m2/s
-                               ( 1.0_wp / emt_att%xm(ispec) ) *              &   ! mole/kg
-                               conv_to_ratio(k,j,i)           *              &   ! m^3/mole
-                               ratio2ppm                      *              &   ! ppm
-                               rho_air(k)                                        ! kg/m^3
+                         surf_lsm_h(0)%cssws(match_spec_model(ispec),m) =       &   ! ppm/s * m * kg/m3
+                               emis_distribution(1,j,i,ispec) *                 &   ! kg/m2/s
+                               ( 1.0_wp / emt_att%xm(ispec) ) *                 &   ! mole/kg
+                               conv_to_ratio(k,j,i)           *                 &   ! m^3/mole
+                               ratio2ppm                      *                 &   ! ppm
+                               rho_air(k)                                           ! kg/m^3
 
                       ENDIF  ! VOC
@@ -1703,9 +1706,9 @@
 !
 !--          USM surfaces
-             DO  m = 1, surf_usm_h%ns
-
-                i = surf_usm_h%i(m)
-                j = surf_usm_h%j(m)
-                k = surf_usm_h%k(m)
+             DO  m = 1, surf_usm_h(0)%ns
+
+                i = surf_usm_h(0)%i(m)
+                j = surf_usm_h(0)%j(m)
+                k = surf_usm_h(0)%k(m)
 
                 IF  ( emis_distribution(1,j,i,ispec) > 0.0_wp )  THEN
@@ -1717,7 +1720,7 @@
                          TRIM( spc_names( match_spec_model(ispec) ) ) == "PM10" )  THEN
 
-                      surf_usm_h%cssws(match_spec_model(ispec),m) =           &    ! kg/m2/s * kg/m3
-                               emis_distribution(1,j,i,ispec) *               &    ! kg/m2/s
-                               rho_air(k)                                           ! kg/m^3
+                      surf_usm_h(0)%cssws(match_spec_model(ispec),m) =           &    ! kg/m2/s * kg/m3
+                               emis_distribution(1,j,i,ispec) *                  &    ! kg/m2/s
+                               rho_air(k)                                             ! kg/m^3
 
                    ELSE
@@ -1728,9 +1731,9 @@
                             emt_att%species_name(match_spec_input(ispec)) == "VOC" )  THEN
 
-                         surf_usm_h%cssws(match_spec_model(ispec),m) =       &   ! ppm/s * m * kg/m3
-                               emis_distribution(1,j,i,ispec) *              &   ! m2/s
-                               conv_to_ratio(k,j,i)           *              &   ! m^3/mole
-                               ratio2ppm                      *              &   ! ppm
-                               rho_air(k)                                        ! kg/m^3
+                         surf_usm_h(0)%cssws(match_spec_model(ispec),m) =       &   ! ppm/s * m * kg/m3
+                               emis_distribution(1,j,i,ispec) *                 &   ! m2/s
+                               conv_to_ratio(k,j,i)           *                 &   ! m^3/mole
+                               ratio2ppm                      *                 &   ! ppm
+                               rho_air(k)                                           ! kg/m^3
 
 !
@@ -1738,10 +1741,10 @@
                       ELSE
 
-                         surf_usm_h%cssws(match_spec_model(ispec),m) =       &   ! ppm/s * m * kg/m3
-                               emis_distribution(1,j,i,ispec) *              &   ! kg/m2/s
-                               ( 1.0_wp / emt_att%xm(ispec) ) *              &   ! mole/kg
-                               conv_to_ratio(k,j,i)           *              &   ! m^3/mole
-                               ratio2ppm                      *              &   ! ppm
-                               rho_air(k)                                        ! kg/m^3
+                         surf_usm_h(0)%cssws(match_spec_model(ispec),m) =       &   ! ppm/s * m * kg/m3
+                               emis_distribution(1,j,i,ispec) *                 &   ! kg/m2/s
+                               ( 1.0_wp / emt_att%xm(ispec) ) *                 &   ! mole/kg
+                               conv_to_ratio(k,j,i)           *                 &   ! m^3/mole
+                               ratio2ppm                      *                 &   ! ppm
+                               rho_air(k)                                           ! kg/m^3
 
 
@@ -2030,8 +2033,8 @@
     cssws_def_h = 0.0_wp
 
-    ALLOCATE( cssws_lsm_h(n_matched_vars,surf_lsm_h%ns) )
+    ALLOCATE( cssws_lsm_h(n_matched_vars,surf_lsm_h(0)%ns) )
     cssws_lsm_h = 0.0_wp
 
-    ALLOCATE( cssws_usm_h(n_matched_vars,surf_usm_h%ns) )
+    ALLOCATE( cssws_usm_h(n_matched_vars,surf_usm_h(0)%ns) )
     cssws_usm_h = 0.0_wp
 
@@ -2043,11 +2046,11 @@
 
 
-    CALL assign_surface_flux ( cssws_lsm_h, surf_lsm_h%ns,                                         &
-                               surf_lsm_h%j, surf_lsm_h%i,                                         &
+    CALL assign_surface_flux ( cssws_lsm_h, surf_lsm_h(0)%ns,                                      &
+                               surf_lsm_h(0)%j, surf_lsm_h(0)%i,                                   &
                                emis_distrib, mass2mole )
 
 
-    CALL assign_surface_flux ( cssws_usm_h, surf_usm_h%ns,                                         &
-                               surf_usm_h%j, surf_usm_h%i,                                         &
+    CALL assign_surface_flux ( cssws_usm_h, surf_usm_h(0)%ns,                                      &
+                               surf_usm_h(0)%j, surf_usm_h(0)%i,                                   &
                                emis_distrib, mass2mole )
 
@@ -2058,10 +2061,10 @@
        ENDDO
 
-       DO m = 1, surf_lsm_h%ns
-          surf_lsm_h%cssws(k,m)    = cssws_lsm_h(k,m)
+       DO m = 1, surf_lsm_h(0)%ns
+          surf_lsm_h(0)%cssws(k,m)  = cssws_lsm_h(k,m)
        ENDDO
 
-       DO m = 1, surf_usm_h%ns
-          surf_usm_h%cssws(k,m)    = cssws_usm_h(k,m)
+       DO m = 1, surf_usm_h(0)%ns
+          surf_usm_h(0)%cssws(k,m)    = cssws_usm_h(k,m)
        ENDDO
 
